#%RAML 1.0
title: Employee REST Service API 

types:
  EmployeeData: !include libraries/employeeDataType.raml
   
uses:  
  deparments: libraries/departments.raml
  common_responses: libraries/responseCodes.raml

traits:
  orderable:
    queryParameters:
      orderBy:
        description: 
          Sort the details of an employee based on the given criteria  eg. employeeId, status 
        type: string
        required: false
       
      order:
        description: Order
        enum: [desc, asc]
        required: false
        default : desc
        
  pageable:
    queryParameters:
      offset:
        description: Skip over a number of elements by specifying an offset value for the query
        type: integer
        required: false
        example: 20
        
      limit:
        description: Limit the number of employees on the response
        type: integer
        required: false
        example: 80
        
resourceTypes:
  entity: !include resourceTypes/entity.raml
  
/employees: 
  type: common_responses.common_response_types
  get:
    description: Retrieve all emoloyees details based on either status OR in order of given field OR an offset and limit
    displayName: Get Employee's details list
    is : [orderable: {fieldsList: "employeeId","status","departmentId"}, pageable]
    queryParameters:
      status:
        required: false
        enum: 
          - Active
          - Resigned
    responses:
      200:
        body:
          application/json:
            type: EmployeeData[]
            example: !include examples/emp-example.json           
  post:
    description: Add employees
    displayName: Create Employees
    body:
      application/json:
        type: EmployeeData[]
        example: !include examples/employeeDetailsRes.json
    responses:
      200:
        body:
          application/json:
            example:
              message: Employees Added 

  /{ID}:
    type: common_responses.common_response_types
    get:
      description: Get particular employee's details
      displayName: Get an Employee's detail       
      responses:
        200:
          body:
            application/json:
              schema: !include libraries/employeeDataType.raml
              example: !include examples/employeeDetail.raml
            
    put:
      description: Update an employee
      displayName: Update an Employee 
      body:
        application/json:
          type: EmployeeData
          example: !include examples/employeeDetail.raml
      responses:
        200:
          body:
            application/json:
              example:
                message: Employee Updated
    delete:
      description: Delete an employee
      displayName: Delete an Employee 
      responses:
        200:
          body:
            application/json:
              example:
                message: Employee Deleted

/departments:
  type:  entity
  get:
    queryParameters:
      flag:
        description: Skip over a number of elements by specifying an offset value for the query
        type: boolean
        required: true
        example: false
    responses:
      200:
        body:
          application/json:
            type: deparments.departments[]
  put:
    body:
      application/json:
        type: deparments.departments
  delete:
    body:
      application/json:
        type: deparments.departments[]
      